#ifndef UI_H
#define UI_H

#include <QWidget>
#include <QMainWindow>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QSlider>
#include <QLabel>
#include <QDir>
#include <QFile>
#include <QMediaPlayer>
#include <QFileDialog>
#include <QStringList>
#include <QMessageBox>
#include <QFont>
#include <QApplication>
#include <QTimer>
#include <QToolButton>
#include <QMenu>
#include <QSystemTrayIcon>
#include <QIcon>
#include <QEvent>
#include <QAction>
#include <QCloseEvent>
#include <QCoreApplication>

#include "icon.h"
#include "../io/aud_file.h"
#include "../io/conf.h"

class Ui : public QWidget
{
    Q_OBJECT

private:

    QLabel          *fileName;
    QSlider         *slider;
    QMediaPlayer    *player;
    AudFile         *ioDev;
    QToolButton     *settings;
    QSystemTrayIcon *trayIcon;
    Conf            *conf;
    QMenu           *menu;
    QMenu           *trayMenu;
    Icon            *pausePlay;
    Icon            *open;
    Icon            *next;
    Icon            *prev;
    Icon            *stop;
    bool             pressed;

    void fileDir(char direction);
    void changeEvent(QEvent *event);
    void closeEvent(QCloseEvent *event);

private slots:

    void error(QMediaPlayer::Error error);
    void sliderPressed();
    void sliderReleased();
    void posChanged(qint64 pos);
    void openDialog();
    void nextFile();
    void prevFile();
    void stopPlayer();
    void play(const QString &path);
    void trayActivated(QSystemTrayIcon::ActivationReason reason);

public:

    Ui(const QStringList &args, QWidget *parent = 0);
};

#endif // UI_H
