#ifndef AUD_FILE_H
#define AUD_FILE_H

#include <QBuffer>
#include <QFile>
#include <QObject>
#include <QString>
#include <QTimer>
#include <QDebug>

class AudFile : public QFile
{
    Q_OBJECT

private:

    qint64 buffRate;
    qint64 offset;
    bool   init;

private slots:

    void delayFinished();

public:

    AudFile(QObject *parent = 0);

    bool   openFile(const QString &path);
    bool   seek(qint64 off);
    qint64 getOffset();
    qint64 getDuration();

    ~AudFile();

signals:

    void posChanged(qint64 off);
    void endOfPlayback();
    void duration(qint64 msec);
};

#endif // AUD_FILE_H
